/* --------------------------- k_send  ----------------------------------- */
/*                                                                              */
/*                                                                              */
/* Most of the source is copied from the send code from pd in the file x_connective.c */
/* Therefore the licence for this object is the same as PD. */
/*                                                                              */
/* ---------------------------------------------------------------------------- */

#include "m_pd.h"
#include <stdio.h>

#include <math.h>
#include <stdlib.h>


static char *version = "k_send v0.1, written by Kjetil S. Matheussen, k.s.matheussen@notam02.no";
 

static t_class *k_send_class;

typedef struct _k_send
{
    t_object x_obj;
    t_symbol *x_sym;
} t_k_send;

static void k_send_bang(t_k_send *x)
{
    if (x->x_sym->s_thing) pd_bang(x->x_sym->s_thing);
}

static void k_send_float(t_k_send *x, t_float f)
{
    if (x->x_sym->s_thing) pd_float(x->x_sym->s_thing, f);
}

static void k_send_symbol(t_k_send *x, t_symbol *s)
{
    if (x->x_sym->s_thing) pd_symbol(x->x_sym->s_thing, s);
}

static void k_send_pointer(t_k_send *x, t_gpointer *gp)
{
    if (x->x_sym->s_thing) pd_pointer(x->x_sym->s_thing, gp);
}

static void k_send_list(t_k_send *x, t_symbol *s, int argc, t_atom *argv)
{
    if (x->x_sym->s_thing) pd_list(x->x_sym->s_thing, s, argc, argv);
}

static void k_send_anything(t_k_send *x, t_symbol *s, int argc, t_atom *argv)
{
    if (x->x_sym->s_thing) typedmess(x->x_sym->s_thing, s, argc, argv);
}

static void k_send_set(t_k_send *x, t_symbol *s)
{
  x->x_sym = s;
}

static void *k_send_new(t_symbol *s)
{
    t_k_send *x = (t_k_send *)pd_new(k_send_class);
    x->x_sym = s;
    return (x);
}

void k_send_setup(void)
{
    k_send_class = class_new(gensym("k_send"), (t_newmethod)k_send_new, 0,
    	sizeof(t_k_send), 0, A_DEFSYM, 0);
    class_addcreator((t_newmethod)k_send_new, gensym("k_s"), A_DEFSYM, 0);
    class_addbang(k_send_class, k_send_bang);
    class_addfloat(k_send_class, k_send_float);
    class_addsymbol(k_send_class, k_send_symbol);
    class_addpointer(k_send_class, k_send_pointer);
    class_addlist(k_send_class, k_send_list);
    class_addanything(k_send_class, k_send_anything);

    class_addmethod(k_send_class, (t_method)k_send_set, gensym("set"),A_SYMBOL, 0);

    post(version);
}



